#######################################################################
#
#    Standbild for Enigma-2
#    Coded by Vali (c)2009
#    Support: www.dreambox-tools.info
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#######################################################################




from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Components.ActionMap import ActionMap
from Components.Pixmap import Pixmap
from Components.AVSwitch import AVSwitch
from Tools.Directories import fileExists
from enigma import getDesktop, ePicLoad
from os import popen



def Plugins(**kwargs):
	return [PluginDescriptor(name="Standbild", where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main)]



def main(session, **kwargs):
	r = popen("grab -v -j100 /tmp/standbild.jpg").readlines()
	w = getDesktop(0).size().width()
	h = getDesktop(0).size().height()
	PreviewString='<screen backgroundColor="#00080808" flags="wfNoBorder" position="0,0" size="'+str(w)+','+str(h)+'" title="Preview">\n'
	PreviewString=PreviewString+' <widget name="Picture" position="0,0" size="'+str(w)+','+str(h)+'" zPosition="3" alphatest="on" />'
	PreviewString=PreviewString+'\n</screen>'
	session.open(StandbildView, PreviewString)
	
	
	
class StandbildView(Screen):
	def __init__(self, session, prvScreen):
		self.skin = prvScreen
		Screen.__init__(self, session)
		self.session = session
		self.whatPic = "/tmp/standbild.jpg"
		self.EXscale = (AVSwitch().getFramebufferScale())
		self.EXpicload = ePicLoad()
		self["Picture"] = Pixmap()
		self["actions"] = ActionMap(["WizardActions"],{"ok": self.close,"back": self.close, }, -1)
		self.EXpicload.PictureData.get().append(self.DecodeAction)
		self.onLayoutFinish.append(self.Show_Picture)

	def Show_Picture(self):
		if fileExists(self.whatPic):
			self.EXpicload.setPara([self["Picture"].instance.size().width(), self["Picture"].instance.size().height(), self.EXscale[0], self.EXscale[1], 0, 1, "#00080808"])
			self.EXpicload.startDecode(self.whatPic)

	def DecodeAction(self, pictureInfo=""):
		if fileExists(self.whatPic):
			ptr = self.EXpicload.getData()
			self["Picture"].instance.setPixmap(ptr)

